# Robot Movement #

### What is this repository for? ###

This project contains Java code for an integer programming (IP) model to solve a [bicriterion routing problem](https://or.stackexchange.com/questions/12451/coverage-path-planning-dilemma-trade-off) posted on Operations Research Stack Exchange. The problem routes a robot over a rectangular grid, with moves (at constant speed) restricted to adjacent squares. Each square has a nonpositive weight, and one criterion is to minimize the sum of the first arrival time at each square multiplied by its weight. The other criterion is to minimize the number of moves required to visit all squares at least once and then return to the origin.

Details of the model can be found in my [blog post](https://orinanobworld.blogspot.com/2024/09/a-bicriterion-movement-model.html). The code requires CPLEX version 12.9 or later.

### License ###
The code here is copyrighted by Paul A. Rubin (yours truly) and licensed under a [Creative Commons Attribution 4.0 International License](https://creativecommons.org/licenses/by/4.0/deed.en). 

