package robot;

/**
 * Objective enumerates possible objective functions for the routing problem.
 *
 * The two component objectives are "distance" (total distance traveled by the
 * robot, or equivalently the time at which it returns to node 0 for the last
 * time) and "delay" (the sum of the time at which each node is visited,
 * weighted by the node's priority).
 *
 * @author Paul A. Rubin (rubin@msu.edu)
 */
public enum Objective {
  /** Objective: minimum distance. */
  DISTANCE,
  /** Objective: minimum delay score. */
  DELAY,
  /** Objective: lexicographic order, with distance primary. */
  DISTANCE_DELAY,
  /** Objective: Lexicographic order, with delay primary. */
  DELAY_DISTANCE;
}
